;Sample demo program to learn how to use trigo tables generated by trigomaker
; by Florian Clavert aka segaman
; segaman@caramail.com
; http://members.xoom.com/segaman89/

	include "doorsos.h"

	xdef	_ti89
	xdef    _main
	xdef	_comment

VALUES	equ 64		;number of cosines & sines values
;%%%%%%%%%%%%%%%%%%%%%%%%%
GET_COS	MACRO		;macro to get a cos from the data
	lea	cos,a0
	add.w	\1,a0
	add.w	\1,a0
	move.w	(a0),\2
	ENDM
;%%%%%%%%%%%%%%%%%%%%%%%%%
GET_SIN	MACRO		;macro to get a sin from the data
	lea	sin,a0
	add.w	\1,a0
	add.w	\1,a0
	move.w	(a0),\2
	ENDM

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
_main:
	bsr	cls
	clr.l	d5
	clr.l	d6
	move.w	#100,d6
\fill:
	bsr	cls
	move.w	#VALUES-1,d7
\loop:
	GET_COS	d7,d3		;get cos(d7) in d3
	muls.l	d5,d3		;d5=radius
	asr.l	#7,d3		;|equ divide d3 by 1024
	asr.l	#3,d3		;|
	add.w	#160/2,d3	;x

	GET_SIN	d7,d4		;get cos(d7) in d4
	muls.l	d5,d4		;d5=radius
	asr.l	#7,d4		;|equ divide d4 by 1024
	asr.l	#3,d4		;|
	add.w	#100/2,d4	;y

	move.w	d3,d0		;x
	move.w	d4,d1		;y
	bsr	putplot		;put a plot at (x=d0,y=d1)

	dbra	d7,\loop
	bsr	pause
	add.w	#1,d5		;radius
	dbra	d6,\fill

	rts
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
pause:				;a small pause
	move.w	d0,-(a7)
	move.w	#10000,d0
\loop	dbf	d0,\loop
	move.w	(a7)+,d0
	rts

_comment dc.b	"Demo by Florian Clavert aka segaman",0
;%%%%%%%%%%%%%%%%%%%%%%%%%
cls:			;just clear the screen
	move.l	#$4c00,a0
	move.w	#750,d0
	add.w	#750*4,a0
\loop	clr.l	-(a0)
	dbf	d0,\loop
	rts
;%%%%%%%%%%%%%%%%%%%%%%%%%
putplot:		;should put a plot at d0,d1
	bsr	putpixel
	add.w	#1,d0
	bsr	putpixel
	add.w	#1,d1
	bsr	putpixel
	sub.w	#1,d0
	bsr	putpixel
	rts
;%%%%%%%%%%%%%%%%%%%%%%%%%
putpixel:		;should put a pixel at d0,d1
	movem.l	a0/d0-d2,-(a7)
	move.l	#$4c00,a0
	cmp.w	#160,d0
	bcc	\clip
	cmp.w	#100,d1
	bcc	\clip
	lsl.w	#1,d1
	move.w	d1,d2
	lsl.w	#4,d1
	sub.w	d2,d1
	move.w	d0,d2
	lsr.w	#3,d0
	add.w	d1,d0
	not.w	d2
	bset.w	d2,0(a0,d0.w)
\clip:
	movem.l	(a7)+,a0/d0-d2
	rts

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;COSINE & SINE tables generated with trigomaker (I love this tool)
;with the paramaters:
;base angle=64
;number of values=64
;number to multiply these values=1024
;number of values per line=15

cos:
 dc.w 1024,1019,1004,979,946,903,851,791,724,649,568,482,391,297,199
 dc.w 100,0,-100,-199,-297,-391,-482,-568,-649,-724,-791,-851,-903,-946,-979
 dc.w -1004,-1019,-1024,-1019,-1004,-979,-946,-903,-851,-791,-724,-649,-568,-482,-391
 dc.w -297,-199,-100,0,100,199,297,391,482,568,649,724,791,851,903
 dc.w 946,979,1004,1019

sin:
 dc.w 0,100,199,297,391,482,568,649,724,791,851,903,946,979,1004
 dc.w 1019,1024,1019,1004,979,946,903,851,791,724,649,568,482,391,297
 dc.w 199,100,0,-100,-199,-297,-391,-482,-568,-649,-724,-791,-851,-903,-946
 dc.w -979,-1004,-1019,-1024,-1019,-1004,-979,-946,-903,-851,-791,-724,-649,-568,-482
 dc.w -391,-297,-199,-100
	end